﻿@{
    ViewData["Title"] = "Home Page";
}

<div class="d-grid gap-2">
    <h1 class="pb-2 mt-4 mb-2 border-bottom">Welcome to TooText</h1>
    <p>@ViewData["Message"]</p>

    <div id="pdfForm">
        <form method="post" enctype="multipart/form-data">
            <input type="file" class="form-control mb-2" name="file" />
            <button class="btn btn-primary" type="submit">Get Text!</button>
        </form>
    </div>
    
    <div id="result">
        <fieldset text="Results:">
            <p>@Html.Raw(ViewBag.Result)</p>
        </fieldset>
    </div>

    <div id="about">
        <button class="btn btn-primary" type="button" data-bs-toggle="collapse" data-bs-target="#aboutContent" aria-expanded="false" aria-controls="aboutContent">
            About
        </button>
        <div id="aboutContent" class="collapse">
            <h3>TooText is a tech demo built with transparency. See how it works while costing $0 to host in Azue.</h3>
            
            <section>
                <h5>Repos: <a href="https://gitlab.com/brad.rykenhuizen">https://gitlab.com/brad.rykenhuizen</a> </h5>
            </section>

            <section>
                <h5>Hosted with Azure using Docker containers. Azure components: </h5>
                <ul>
                    <li>Resource Group (This is to group all my Azure resources for this project)</li>
                    <li>App Service(F1/Linux) X2 (Hosting for the Website and API. Free, but not exactly fast.  This also forces you to have '.azurewebsites.net' as part of your site name)</li>
                    <li>API Management service(Consumption) (This lets lets you use your API on Azure. This tier has 4.48m calls a month for free; which should be more then enough.) </li>
                    <li>Container registry (I am publishing my containers to Azure using a registry. This stores my deployment containers in Azure.  This isn't necessary {or free at $4/month} but I wanted to try it out.</li>
                </ul>
            </section>
            
            <section>
                <h5>Buzzwords... err, technologies used for this:</h5>
                <ul>
                    <li>Azure</li>
                    <li>Docker</li>
                    <li>.Net Framework 5.0</li>
                    <li>MVC</li>
                    <li>CSS</li>
                    <li>REST web service</li>
                    <li>iText7</li>
                </ul>
            </section>

            <section>
                <h5>CI/CD: Coming soon!</h5>
            </section>
            
            
            <section id="flowChart">
                <h5>Flowchart:</h5>
                <div><img src="img/TooTextFlow.jpg" alt="An incredibly impressive flow chart" /></div>
            </section>
            
            <section>
                <h5>Decisions:</h5>
                <ul>
                    <li>Passing a memory stream to the API: This eats up a lot of bandwidth because you're passing what could be large binary data 
                        payloads back and forth. In this case, I doubt this page will be so popular that this issue would be a problem. One solution 
                        to mitigate a lot of the network traffic is to save the binary (the PDF file) to a database and have the api access the 
                        database instead of passing it over HTTP</li>
                    <li>Using Azure: I was already familiar with Azure, so it was a no brainer for me. It's very fast to deploy from Visual Studio 
                        and the price is right. I may eventually also host this on another platform like AWS after CI/CD is done.</li>
                </ul>
            </section>
            
        </div>
    </div>

    <div id="contact">
        <button class="btn btn-primary" type="button" data-bs-toggle="collapse" data-bs-target="#contactContent" aria-expanded="false" aria-controls="aboutContent">
            Contact
        </button>
        <br />
        <div id="contactContent" class="collapse">
            <h5>Linkedin: <a href="https://www.linkedin.com/in/bradrykenhuizen/">https://www.linkedin.com/in/bradrykenhuizen/</a></h5>
        </div>
    </div>

</div>
